SystemOrganization addCategory: #'PBE-LightsOut'!

Trait named: #TAuthor
	uses: {}
	category: 'PBE-LightsOut'!

!TAuthor methodsFor: 'as yet unclassified' stamp: 'MichaelJForster 1/10/2014 12:51'!
author
	"Answer author initials"
	^ 'mjf'! !

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell commentStamp: '<historical>' prior: 0!
A LOCell is cell in the game board, LOGame, of the Lights Out game.!

!LOCell methodsFor: 'initialization' stamp: 'MichaelJForster 1/8/2014 19:26'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!LOCell methodsFor: 'accessing' stamp: 'MichaelJForster 1/8/2014 19:49'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!LOCell methodsFor: 'event handling' stamp: 'MichaelJForster 1/9/2014 05:49'!
mouseMOve: anEvent! !

!LOCell methodsFor: 'event handling' stamp: 'MichaelJForster 1/8/2014 19:50'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #LOGame
	uses: TAuthor
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame commentStamp: '<historical>' prior: 0!
A LOGame is the game board of the Lights Out game.!

LOGame class
	uses: TAuthor classTrait
	instanceVariableNames: ''!

!LOGame methodsFor: 'initialization' stamp: 'MichaelJForster 1/8/2014 19:53'!
cellsPerSide
	"Answer the number of cells along each side of the game board."
	^ 10! !

!LOGame methodsFor: 'initialization' stamp: 'MichaelJForster 1/8/2014 19:36'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width * n)@(height * n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ]! !

!LOGame methodsFor: 'initialization' stamp: 'MichaelJForster 1/9/2014 05:45'!
newCellAt: i at: j
	"Create a cell for position (i, j) and add it to my on-screen representation at the appropriate screen position.  Answer the new cell."
	
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [ self toggleNeighboursOfCellAt: i at: j ].
	^ c! !

!LOGame methodsFor: 'game logic' stamp: 'MichaelJForster 1/8/2014 19:48'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j) toggleState ].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState ].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState ].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState ]! !
